import time
class State:
    def __init__(self, name, description):
        self.name=name
        self.description=description
        self.edges=[]

class Edge:
    def __init__(self, from_node, commands, to_node, descrpition, healthpoint, constraints=None):
        self.from_node=from_node
        self.commands=commands
        self.to_node=to_node
        self.constraints=constraints
        self.healthpoint=healthpoint
        self.descrpition=descrpition

class Object:
    def __init__(self, original_location, object_name, description_short, description_long, weight ):
        self.original_location=original_location
        self.object_name=object_name
        self.description_short=description_short
        self.description_long=description_long
        self.weight=weight
        

class Constraint:
    def __init__(self, ID, object_name, location):
        self.ID=ID
        self.object_name=object_name
        self.location=location

class Maxweight:
    def __init__(self, name, weight):
        self.name=name
        self.weight=int(weight)

class Engine:
    def __init__(self, filename):
        self.filename=filename
        self.initial_state=None

    def linebreak(text,col=80):
        retval= ""
        count = 0
        for c in text:
            if count > col and c ==" ":
                retval +="\n"
                count=0
            else:
                retval += c
                count += 1
        return retval
        
    def load(self):
        self.states={}
        edges=[]
        self.objects=[]
        self.constraints=[]
        self.backpack=None
        fp=open(self.filename)
        for line in fp:
            if len(line)==0 or line[0] == '#':
                continue
            items = line.strip().split("::")
            if items[0] =='node':
                s=State(*items[1:])
                if self.initial_state is None:
                    self.initial_state=s
                self.states[items[1]]=s
            elif items[0]=='edge':
                edges.append(Edge(*items[1:]))
            elif items[0]=='object':
                self.objects.append(Object(*items[1:]))
            elif items[0]=='constraint':
                self.constraints.append(Constraint(*items[1:]))
            elif items[0]=='backpack':
                self.backpack=Maxweight(*items[1:])
        for edge in edges:
            self.states[edge.from_node].edges.append(edge)

            

    def play(self):
        current_state=self.initial_state
        picked_object=None
        constraint_checker=0
        health_point=10
        total_weight=0
        init_time=time.time()
        print ("Hey! Welcome to the game written by Tong Wu. Enjoy the game! But, may I have your name first please?")
        player_name=raw_input("Player Name")
        print ("Hello! %s, now let us start the magic game!") %player_name
        move=0
        while health_point>0:
            passed_time=time.time()-init_time
            print ("You just made your decision and %d seconds have passed.") %passed_time
            picked_object=None
            object_in_backpack=[]
            current_object=[]
            print(current_state.description)
            for object in self.objects:
                if object.original_location == current_state.name:
                    print ("%s is on the floor.") %object.object_name
                    print(object.description_short)
                    current_object.append(object)
                    picked_object=object
            command=raw_input("Command> ")
            if command== "pick":
                if total_weight>self.backpack.weight:
                    print ("Your backpack is too heavy. You can't hold that much. So I really suggest you to drop something.")
                else:
                    if len(current_object)>0 :
                        current_object[0].original_location="backpack"
                        total_weight=total_weight+int(current_object[0].weight)
                        print ("Your current total weight is %s.") %total_weight
                        print ("Great you have the energy to continue now") 
            if command=="pick":
                if total_weight>self.backpack.weight:
                    print ("Your backpack is too heavy. You can't hold that much. So I really suggest you to drop something.") 
                else:
                    if len(current_object)==0 :
                        print ("I didn't see you thing you want here. Double check.")
            if command=="drop":
                for object in self.objects:
                    print ("Test:") ,object
                    if object.original_location=="backpack":
                        object_in_backpack.append(object)
                if len(object_in_backpack)>0:
                    object_in_backpack[0].original_location=current_state.name
                    total_weight=total_weight-int(object_in_backpack[0].weight)
                    print ("Your current total weight is %s.") %total_weight
                else:
                    print ("Are you sure? There is nothing is your bag and you have nothing to drop.")
            if command=="look":
                for object in self.objects:
                    print (object.object_name)
                    print (object.description_short)
            if command=="help":
                print ("Do you want hint?")
                if command=="yes":
                    print ("You should go from here %s") %current_state.edge.to_node    
                        
            else:
                for edge in current_state.edges:
                    if command in edge.commands:
                        if edge.constraints ==None:
                            current_state = self.states[edge.to_node]
                            health_point=health_point+int(edge.healthpoint)
                            print ("Your health point is now %s.") %health_point
                            move=move+1
                            print ("This is the %d move.") %move
                            break
                        if edge.constraints !=None:
                            for constraint in self.constraints:
                                if constraint.ID == edge.constraints:
                                    for object in self.objects:
                                        constraint_checker=constraint_checker+1
                                        if object.original_location==constraint.location and object.object_name == constraint.object_name :
                                            current_state = self.states[edge.to_node]
                                            health_point=health_point+int(edge.healthpoint)
                                            print ("Your health point is now %s.") %health_point
                                            break
                                            move=move+1
                                            print ("This is the %d move.") %move
                                            
                                        if constraint_checker==len(self.constraints):
                                                print ("Oh~ It is so sad that you cannot figure out the way. You haven't done what you have to do to go through here!")
                                                constraint_checker=0
            
        print ("Oh~You have used up your health point. You should get some more sleep during the final week. Get some more sleep and I will see you next time!")
        

game=Engine("game.txt")
game.load()
game.play()
